using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;
namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_SMS_SentSMS
    /// </summary>
    public partial class T_SMS_SentSMS
    {
        public T_SMS_SentSMS()
        { }
        #region  Method

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("SMSID", "T_SMS_SentSMS");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int SMSID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_SMS_SentSMS");
            strSql.Append(" where SMSID=@SMSID ");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)};
            parameters[0].Value = SMSID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_SMS_SentSMS model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_SMS_SentSMS(");
            strSql.Append("SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,MaxSendCount,CurSentCount,Info,SendModemIMEI,F_UserID,F_CustomerID,F_Name)");
            strSql.Append(" values (");
            strSql.Append("@SMSID,@TelNum,@Content,@CommitTime,@State,@SendTime,@LastSentTime,@MaxSendCount,@CurSentCount,@Info,@SendModemIMEI,@F_UserID,@F_CustomerID,@F_Name)");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4),
					new SqlParameter("@TelNum", SqlDbType.VarChar,20),
					new SqlParameter("@Content", SqlDbType.NVarChar,100),
					new SqlParameter("@CommitTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.Int,4),
					new SqlParameter("@SendTime", SqlDbType.DateTime),
					new SqlParameter("@LastSentTime", SqlDbType.DateTime),
					new SqlParameter("@MaxSendCount", SqlDbType.Int,4),
					new SqlParameter("@CurSentCount", SqlDbType.Int,4),
					new SqlParameter("@Info", SqlDbType.NVarChar,50),
					new SqlParameter("@SendModemIMEI", SqlDbType.VarChar,20),
					new SqlParameter("@F_UserID", SqlDbType.Int,4),
					new SqlParameter("@F_CustomerID", SqlDbType.Int,4),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.SMSID;
            parameters[1].Value = model.TelNum;
            parameters[2].Value = model.Content;
            parameters[3].Value = model.CommitTime;
            parameters[4].Value = model.State;
            parameters[5].Value = model.SendTime;
            parameters[6].Value = model.LastSentTime;
            parameters[7].Value = model.MaxSendCount;
            parameters[8].Value = model.CurSentCount;
            parameters[9].Value = model.Info;
            parameters[10].Value = model.SendModemIMEI;
            parameters[11].Value = model.F_UserID;
            parameters[12].Value = model.F_CustomerID;
            parameters[13].Value = model.F_Name;

            return DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);

        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_SMS_SentSMS model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_SMS_SentSMS set ");
            strSql.Append("TelNum=@TelNum,");
            strSql.Append("Content=@Content,");
            strSql.Append("CommitTime=@CommitTime,");
            strSql.Append("State=@State,");
            strSql.Append("SendTime=@SendTime,");
            strSql.Append("LastSentTime=@LastSentTime,");
            strSql.Append("MaxSendCount=@MaxSendCount,");
            strSql.Append("CurSentCount=@CurSentCount,");
            strSql.Append("Info=@Info,");
            strSql.Append("SendModemIMEI=@SendModemIMEI,");
            strSql.Append("F_UserID=@F_UserID,");
            strSql.Append("F_CustomerID=@F_CustomerID,");
            strSql.Append("F_Name=@F_Name");
            strSql.Append(" where SMSID=@SMSID ");
            SqlParameter[] parameters = {
					new SqlParameter("@TelNum", SqlDbType.VarChar,20),
					new SqlParameter("@Content", SqlDbType.NVarChar,100),
					new SqlParameter("@CommitTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.Int,4),
					new SqlParameter("@SendTime", SqlDbType.DateTime),
					new SqlParameter("@LastSentTime", SqlDbType.DateTime),
					new SqlParameter("@MaxSendCount", SqlDbType.Int,4),
					new SqlParameter("@CurSentCount", SqlDbType.Int,4),
					new SqlParameter("@Info", SqlDbType.NVarChar,50),
					new SqlParameter("@SendModemIMEI", SqlDbType.VarChar,20),
					new SqlParameter("@F_UserID", SqlDbType.Int,4),
					new SqlParameter("@F_CustomerID", SqlDbType.Int,4),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
					new SqlParameter("@SMSID", SqlDbType.Int,4)};
            parameters[0].Value = model.TelNum;
            parameters[1].Value = model.Content;
            parameters[2].Value = model.CommitTime;
            parameters[3].Value = model.State;
            parameters[4].Value = model.SendTime;
            parameters[5].Value = model.LastSentTime;
            parameters[6].Value = model.MaxSendCount;
            parameters[7].Value = model.CurSentCount;
            parameters[8].Value = model.Info;
            parameters[9].Value = model.SendModemIMEI;
            parameters[10].Value = model.F_UserID;
            parameters[11].Value = model.F_CustomerID;
            parameters[12].Value = model.F_Name;
            parameters[13].Value = model.SMSID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SentSMS ");
            strSql.Append(" where SMSID=@SMSID ");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)};
            parameters[0].Value = SMSID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public bool Delete(string arrSMSID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SentSMS ");
            strSql.Append(" where SMSID in (" + arrSMSID + ") ");

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public int ReSend(string arrSMSID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_SMS_SendSMSTask(");
            strSql.Append("TelNum,Content,CommitTime,State,SendTime,LastSentTime,CurSentCount,MaxSendCount,Info,F_UserID,F_CustomerID,F_Name)");
            strSql.Append(" select TelNum,Content,getdate(),0,getdate(),null,0,MaxSendCount,'',F_UserID,F_CustomerID,F_Name ");
            strSql.Append(" from T_SMS_SentSMS ");
            strSql.Append(" where SMSID in (" + arrSMSID + ") ");

            return DbHelperSQL.ExecuteSql(strSql.ToString());
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string SMSIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_SentSMS ");
            strSql.Append(" where SMSID in (" + SMSIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_SMS_SentSMS GetModel(int SMSID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,MaxSendCount,CurSentCount,Info,SendModemIMEI,F_UserID,F_CustomerID,F_Name from T_SMS_SentSMS ");
            strSql.Append(" where SMSID=@SMSID ");
            SqlParameter[] parameters = {
					new SqlParameter("@SMSID", SqlDbType.Int,4)};
            parameters[0].Value = SMSID;

            CallCenterApi.Model.T_SMS_SentSMS model = new CallCenterApi.Model.T_SMS_SentSMS();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["SMSID"] != null && ds.Tables[0].Rows[0]["SMSID"].ToString() != "")
                {
                    model.SMSID = int.Parse(ds.Tables[0].Rows[0]["SMSID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["TelNum"] != null && ds.Tables[0].Rows[0]["TelNum"].ToString() != "")
                {
                    model.TelNum = ds.Tables[0].Rows[0]["TelNum"].ToString();
                }
                if (ds.Tables[0].Rows[0]["Content"] != null && ds.Tables[0].Rows[0]["Content"].ToString() != "")
                {
                    model.Content = ds.Tables[0].Rows[0]["Content"].ToString();
                }
                if (ds.Tables[0].Rows[0]["CommitTime"] != null && ds.Tables[0].Rows[0]["CommitTime"].ToString() != "")
                {
                    model.CommitTime = DateTime.Parse(ds.Tables[0].Rows[0]["CommitTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["State"] != null && ds.Tables[0].Rows[0]["State"].ToString() != "")
                {
                    model.State = int.Parse(ds.Tables[0].Rows[0]["State"].ToString());
                }
                if (ds.Tables[0].Rows[0]["SendTime"] != null && ds.Tables[0].Rows[0]["SendTime"].ToString() != "")
                {
                    model.SendTime = DateTime.Parse(ds.Tables[0].Rows[0]["SendTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["LastSentTime"] != null && ds.Tables[0].Rows[0]["LastSentTime"].ToString() != "")
                {
                    model.LastSentTime = DateTime.Parse(ds.Tables[0].Rows[0]["LastSentTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["MaxSendCount"] != null && ds.Tables[0].Rows[0]["MaxSendCount"].ToString() != "")
                {
                    model.MaxSendCount = int.Parse(ds.Tables[0].Rows[0]["MaxSendCount"].ToString());
                }
                if (ds.Tables[0].Rows[0]["CurSentCount"] != null && ds.Tables[0].Rows[0]["CurSentCount"].ToString() != "")
                {
                    model.CurSentCount = int.Parse(ds.Tables[0].Rows[0]["CurSentCount"].ToString());
                }
                if (ds.Tables[0].Rows[0]["Info"] != null && ds.Tables[0].Rows[0]["Info"].ToString() != "")
                {
                    model.Info = ds.Tables[0].Rows[0]["Info"].ToString();
                }
                if (ds.Tables[0].Rows[0]["SendModemIMEI"] != null && ds.Tables[0].Rows[0]["SendModemIMEI"].ToString() != "")
                {
                    model.SendModemIMEI = ds.Tables[0].Rows[0]["SendModemIMEI"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_UserID"] != null && ds.Tables[0].Rows[0]["F_UserID"].ToString() != "")
                {
                    model.F_UserID = int.Parse(ds.Tables[0].Rows[0]["F_UserID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CustomerID"] != null && ds.Tables[0].Rows[0]["F_CustomerID"].ToString() != "")
                {
                    model.F_CustomerID = int.Parse(ds.Tables[0].Rows[0]["F_CustomerID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Name"] != null && ds.Tables[0].Rows[0]["F_Name"].ToString() != "")
                {
                    model.F_Name = ds.Tables[0].Rows[0]["F_Name"].ToString();
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,MaxSendCount,CurSentCount,Info,SendModemIMEI,F_UserID,F_CustomerID,F_Name ");
            strSql.Append(" FROM T_SMS_SentSMS ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" SMSID,TelNum,Content,CommitTime,State,SendTime,LastSentTime,MaxSendCount,CurSentCount,Info,SendModemIMEI,F_UserID,F_CustomerID,F_Name ");
            strSql.Append(" FROM T_SMS_SentSMS ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_SMS_SentSMS";
            parameters[1].Value = "SMSID";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}


